<?php
/**
 * The admin menu pages
 */

class GOON_Admin_Menu_Pages {

	function __construct() {
        
        add_action( 'admin_menu', [ $this, 'add_menu_pages' ] );
	}

	/**
	 * Add Menu Pages
	 */
	function add_menu_pages() {
        
        // TODO SWITCH

		add_menu_page( 'Goon', 'Goon', 'manage_options', 'goon', [ $this, 'render_overview_page' ], 'none' );
		add_submenu_page( 'goon', 'Overview',           'Overview',             'manage_options', 'goon',                    [ $this, 'render_overview_page'           ] );
		add_submenu_page( 'goon', 'Filters',            'Filters',              'manage_options', 'goon_filters',            [ $this, 'render_filters_page'            ] );
        
		// add_menu_page( 'Goon', 'Goon', 'manage_options', 'goon', [ $this, 'render_filters_page' ], 'none' );
		// add_submenu_page( 'goon', 'Filters',            'Filters',              'manage_options', 'goon',                    [ $this, 'render_filters_page'            ] );
        
        // and goon\admin\js\goon-admin.js
        
		add_submenu_page( 'goon', 'Filter',             'Create Filter',        'manage_options', 'goon_add_filters',        [ $this, 'render_add_filters_page'        ] );
		add_submenu_page( 'goon', 'Groups',             'Groups',               'manage_options', 'goon_groups',             [ $this, 'render_groups_page'             ] );
		add_submenu_page( 'goon', 'Group',              'Create Group',         'manage_options', 'goon_add_groups',         [ $this, 'render_add_groups_page'         ] );
		add_submenu_page( 'goon', 'Filter Categories',  'Filter Categories',    'manage_options', 'goon_filters_categories', [ $this, 'render_filters_categories_page' ] );
		add_submenu_page( 'goon', 'Filter Category',    'Create Category',      'manage_options', 'goon_add_categories',     [ $this, 'render_add_category_page'       ] );
		add_submenu_page( 'goon', 'Settings',           'Settings',             'manage_options', 'goon_settings',           [ $this, 'render_settings_page'           ] );
		// add_submenu_page( 'goon', 'Support',            'Support',              'manage_options', 'goon_support',            [ $this, 'render_support_page'            ] );

	}


	function render_overview_page() {
		include 'pages/page-overview.php';
	}

	function render_filters_page() {
		include 'pages/page-filters-list.php';
	}

	function render_add_filters_page() {
		include 'pages/page-filters-edit.php';
	}

	function render_groups_page() {
		include 'pages/page-groups-list.php';
	}

	function render_add_groups_page() {
		include 'pages/page-groups-edit.php';
	}

	function render_filters_categories_page() {
		include 'pages/page-categories-list.php';
	}

	function render_add_category_page() {
		include 'pages/page-categories-edit.php';
	}

	function render_settings_page() {
		include 'pages/page-settings.php';
	}

	function render_support_page() {
		include 'pages/page-support.php';
	}

}

