<?php

$plugins = GOON_Admin_Helper::get_plugins_with_status();
$groups = get_posts( [
    'post_type'   => 'goon_group',
    'numberposts' => -1,
] );
if ( $groups ) {
    usort( $groups, "GOON_Admin_Helper::sort__by_post_title" );
}
$categories = get_categories( [
    'taxonomy'   => 'goon_categories',
    'type'       => 'goon_filter',
    'hide_empty' => 0,
] );
// goon_mu_plugin()->write_log( $categories, "page-add-filters-categories" );
// defaults
$page_title = "Create a new Filter";
$filter_title = "";
$filter_type = "_endpoint";
$plugins_to_block = [];
$groups_to_block = [];
$filter_categories = [];
$endpoints = [];
$ajax_actions = [];
$css_files = [];
$js_files = [];
$turned_off = true;
$turned_on_checked = '';
// Editing existing filter?
$filter_id = ( !empty($_GET["filter_id"]) ? intval( $_GET["filter_id"] ) : false );
$filter = ( $filter_id ? get_post( $filter_id ) : false );

if ( $filter ) {
    $page_title = "Editing filter: " . $filter->post_title;
    $filter_title = $filter->post_title;
    $filter_type = get_post_meta( $filter->ID, "filter_type", true );
    $plugins_to_block = get_post_meta( $filter->ID, "plugins_to_block", true );
    $groups_to_block = get_post_meta( $filter->ID, "groups_used", true );
    $filter_categories = get_post_meta( $filter->ID, "categories", true );
    $turned_off = get_post_meta( $filter->ID, 'turned_off', true );
    $is_or_not = get_post_meta( $filter->ID, "is_or_not", true );
    $endpoints = GOON_Admin_Helper::get_filter_endpoints( $filter );
    $turned_on_checked = ( $turned_off !== "1" ? ' checked="checked"' : '' );
    $plugins_to_block = ( !empty($plugins_to_block) ? array_keys( $plugins_to_block ) : [] );
    $groups_to_block = ( !empty($groups_to_block) ? array_keys( $groups_to_block ) : [] );
    $filter_categories = ( !empty($filter_categories) ? array_keys( $filter_categories ) : [] );
    // goon_mu_plugin()->write_log( $groups_to_block, "goon_mu_plugin()-page-filters-edit-groups_to_block" );
} elseif ( !empty($_GET["new_title"]) && !empty($_GET["new_link"]) ) {
    $filter_title = sanitize_text_field( $_GET["new_title"] );
    $endpoints = [ esc_url_raw( $_GET["new_link"] ) ];
}

$dynamic_class = '';
if ( empty($endpoints[0]) || !empty($endpoints[0]) && (strpos( $endpoints[0], '*' ) !== false || strpos( $endpoints[0], '+' ) !== false) ) {
    $dynamic_class = ' dynamic_endpoint';
}
?>

<div class="goon-wrap">

    <?php 
GOON_Admin_Helper::content_part__header( $page_title, "filters" );
?>
    
	<div id="edit_filter" class="goon-content">
    
		<div class="row content-new-element">
			<div class="col-12">
				<div class="content-filter">
                
					<div class="row filter_title">
                        
                        <input type="hidden" name="GOON_filter_data[ID]" value="<?php 
echo  ( $filter ? esc_attr( $filter->ID ) : "" ) ;
?>"/>
                        
						<div class="col-8">
							<div class="header">Title</div>
							<div>
								<div class="content enter-data">
									<span><input class="content-text" id="set_title" type="text" name="GOON_filter_data[title]" value="<?php 
echo  esc_attr( $filter_title ) ;
?>" placeholder="The title of this filter"></span>
								</div>
							</div>
						</div>
                        
						<div class="col-3">
							<div class="header">Trigger Type</div>
							<div>
								<div class="content enter-data">
                                    <span>
                                        <select name="GOON_filter_data[type]" id="set_filter_type" data-selected="<?php 
echo  esc_attr( $filter_type ) ;
?>">
                                            <optgroup label="Default:">
                                            
                                                <option value="_endpoint">Endpoint(s)</option>
                                                
                                            <?php 
?>
                                            
                                            </optgroup>
                                            <optgroup label="Edit page of a Post Type:" id="select_post_types"></optgroup>
                                        </select>
                                        <span id="loading_post_types">Loading..</span>
                                    </span>
								</div>
							</div>
						</div>
                      
						<div class="col-1">
							<div class="header toggle_filter_header">Turned On</div>
                            <div class="toggle_filter">
                                <label>
                                    <span class="switch">
                                        <input name="GOON_filter_data[turned_on]" type="checkbox"<?php 
echo  $turned_on_checked ;
?>/>
                                        <span class="slider round"></span>
                                    </span>
                                </label>
                            </div>
						</div>
                        
					</div>
					
                    <div class="row select_trigger" id="endpoints_wrapper">
                    
						<div class="">
							<div class="header">Endpoints</div>
							<small class="description">The URL of the page being loaded has to match any of the "is" rules and none of the "is not" rules.</small>
						</div>
                        
						<div class="additional_endpoint_wrapper">
                            <select class="is_or_not" name="GOON_filter_data[is_or_not][]">
                                <option value="is" selected="selected">- is -</option>
                            </select>
                            <a class="home_url<?php 
echo  $dynamic_class ;
?>" target="_goon_preview" href="javascript:void(0);"><?php 
echo  home_url() ;
?></a>
                            <input id="first_endpoint" type="text" name="GOON_filter_data[endpoints][]" placeholder="Put your URL here" value="<?php 
echo  ( !empty($endpoints) ? esc_attr( $endpoints[0] ) : "" ) ;
?>"/>
                            <div id="add_endpoint" class="circle_button add_something">+</div>
						</div>
                        
                        <?php 
for ( $i = 1 ;  $i < count( $endpoints ) ;  $i++ ) {
    ?>
                        
                            <?php 
    $dynamic_class = ( strpos( $endpoints[$i], '*' ) !== false || strpos( $endpoints[$i], '+' ) !== false ? ' dynamic_endpoint' : '' );
    ?>
                        
                            <div class="additional_endpoint_wrapper">
                                <select class="is_or_not" name="GOON_filter_data[is_or_not][]">
                                    <option value="is" <?php 
    echo  ( empty($is_or_not[$i]) || $is_or_not[$i] !== 'is' ? ' selected="selected"' : "" ) ;
    ?>>- is -</option>
                                    <option value="is_not"<?php 
    echo  ( !empty($is_or_not[$i]) && $is_or_not[$i] === 'is_not' ? ' selected="selected"' : "" ) ;
    ?>>- is not -</option>
                                </select>
                                <a class="home_url<?php 
    echo  $dynamic_class ;
    ?>" target="_goon_preview" href="javascript:void(0);"><?php 
    echo  home_url() ;
    ?></a>
                                <input class="additional_endpoint" type="text" name="GOON_filter_data[endpoints][]" placeholder="Put your URL here" value="<?php 
    echo  esc_attr( $endpoints[$i] ) ;
    ?>"/>
                                <div class="remove_additional_endpoint circle_button remove_something">-</div>
                            </div>
                            
                        <?php 
}
?>
                        
					</div>
					
                <?php 
?>
                
                    <div class="row block-plugin-wrapper">
						<div class="col-12">
                        
							<div class="header">
								<div class="title">Plugins <span class="disabled">- <?php 
echo  count( $plugins["all"] ) ;
?></span></div>
								<span class="count-plugin">( Active: <?php 
echo  count( $plugins["active"] ) ;
?>   |   Inactive: <?php 
echo  count( $plugins["inactive"] ) ;
?> )</span>
								<span class="all-check toggle_plugins">Disable All</span>
							</div>
                            
                            <div class="header attribute-plugin">Active plugins</div>
                            
							<?php 
GOON_Admin_Helper::content_part__plugins( [
    "plugins"  => $plugins["active"],
    "inactive" => [],
    "blocked"  => $plugins_to_block,
] );
?>
                            
                            <div class="header attribute-plugin" style="margin-top: 10px;">Inactive plugins</div>
                            
							<?php 
GOON_Admin_Helper::content_part__plugins( [
    "plugins"  => $plugins["inactive"],
    "inactive" => $plugins["inactive"],
    "blocked"  => $plugins_to_block,
] );
?>
                            
						</div>
					</div>
                    
                <?php 

if ( $groups ) {
    ?>
					
					<div class="row block-group-plugin-wrapper">
						<div class="col-12">
							<div class="header">
								<div class="title">Filter Groups <span class="disabled">- <?php 
    echo  count( $groups ) ;
    ?></span>
								</div>
								<span class="all-check toggle_groups">Disable All</span>
							</div>
							<div class="special_grid_list">
								<?php 
    foreach ( $groups as $group ) {
        $block_plugins_in_group = get_post_meta( $group->ID, 'group_plugins', true );
        $selected = in_array( $group->ID, $groups_to_block );
        $blocked = ( $selected ? " blocked" : "" );
        $checked = ( $selected ? ' checked="checked"' : '' );
        ?>
										<div class="single_group content<?php 
        echo  $blocked ;
        ?>" data-plugins="<?php 
        echo  htmlspecialchars( json_encode( $block_plugins_in_group ) ) ;
        ?>">
                                            <input class="noeyes" type="checkbox" name="GOON_filter_data[groups][<?php 
        echo  esc_attr( $group->ID ) ;
        ?>]" value="<?php 
        echo  esc_attr( $group->post_title ) ;
        ?>"<?php 
        echo  $checked ;
        ?>/>
											<span><?php 
        echo  $group->post_title ;
        ?></span>
											<?php 
        foreach ( $block_plugins_in_group as $block_plugin_in_group ) {
            ?>
												<div class="hidden_content">
													- <span><?php 
            echo  $block_plugin_in_group ;
            ?></span>
												</div>
											<?php 
        }
        ?>
										</div>
									<?php 
    }
    ?>
							</div>
						</div>
					</div>
                    
                <?php 
}

?>
                
                <?php 
?>
                
                <?php 
?>
                
					<div class="row category-wrapper">
						<div class="col-12">
							<div class="header">
								<div class="title">Categories</div>
							</div>
                            
							<div class="special_grid_list">
								<?php 
if ( $categories ) {
    foreach ( $categories as $cat ) {
        $selected = ( is_array( $filter_categories ) ? in_array( $cat->term_id, $filter_categories ) : false );
        $checked = ( $selected ? ' checked="checked"' : '' );
        ?>
										<div class="single_category content<?php 
        echo  ( $selected ? " blocked" : "" ) ;
        ?>">
                                            <input class="noeyes" type="checkbox" name="GOON_filter_data[categories][<?php 
        echo  $cat->term_id ;
        ?>]" value="<?php 
        echo  esc_attr( $cat->cat_name ) ;
        ?>"<?php 
        echo  $checked ;
        ?>/>
											<span value="<?php 
        echo  esc_attr( $cat->term_id ) ;
        ?>"><?php 
        echo  $cat->cat_name ;
        ?></span>
										</div>
									<?php 
    }
}
?>
                                
                                    <div class="content before_add" id="add_category">
                                        <span class="circle_button add_something before_add">+</span><span class="before_add"> Create New</span>
                                        <input class="during_add" type="text" name="new_category_name" value="" placeholder="Category Name"/>
                                        <span class="circle_button remove_something during_add cancel">-</span>
                                        <span class="circle_button add_something during_add ok">&#10003;</span>
                                    </div>
                                    
							</div>
                            
						</div>
					</div>

				</div>
            
				<div class="row">
					<button id="save_filter" class="goon_green_button">Save Filter</button>
				</div>

			</div>
		</div>
        
	</div>
</div>
