<?php

$filters = get_posts( array(
    'post_type'   => 'goon_filter',
    'post_status' => [ 'publish', 'trash' ],
    'numberposts' => -1,
) );
if ( $filters ) {
    usort( $filters, "GOON_Admin_Helper::sort__by_post_title" );
}
?>

<div class="goon-wrap">

    <?php 
GOON_Admin_Helper::content_part__header( "Filters", "filters" );
?>
    
    <div class="goon-content">
        <div class="justify-content-between global-information">
        
            <div class="col-9 left_information">
                <a href="<?php 
echo  esc_url( admin_url( 'admin.php?page=goon_add_filters' ) ) ;
?>">
                    <button class="goon_green_button" id="add_elements">Create Filter</button>
                </a>
                
                <?php 
GOON_Admin_Helper::content_part__bulk_actions( true );
?>
                
                <?php 
GOON_Admin_Helper::content_part__manipulate_filter_options();
?>
                
                <?php 
GOON_Admin_Helper::content_part__manipulate_toggle_columns();
?>
                
            </div>
            
            <div class="col-3 quantity">
                <span id="all_elements" class="filtered">Published</span> (<span id="count_all_elements"><?php 
echo  wp_count_posts( 'goon_filter' )->publish ;
?></span>)
                |
                <span id="trash_elements">Trashed</span> (<span id="count_trash_elements"><?php 
echo  wp_count_posts( 'goon_filter' )->trash ;
?></span>)
            </div>
            
        </div>
        
        <?php 
GOON_Admin_Helper::content_part__filter_options( $filters );
?>
        
        <?php 
GOON_Admin_Helper::content_part__toggle_columns_options();
?>
        
        <?php 
?>
        
        <div>
            <table class="goon_table">
                <thead>
                
                    <tr id="search_boxes" class="toggle_filter_options hidden">
                        <th data-label="checkbox"></th>
                        <th data-label="title" class="align-left"><input type="text" placeholder="Search Title..." class="search_filter"/></th>
                        <th data-label="categories" class="align-left"><input type="text" placeholder="Search Categories..." class="search_filter"/></th>
                        <th data-label="triggers"><input type="text" placeholder="Search Triggers..." class="search_filter"/></th>
                        <th data-label="plugins_tooltip"><input type="text" placeholder="Search Plugins..." class="search_filter"/></th>
                        <th class="toggle_filter"></th>
                    </tr>
                
                    <tr id="goon_table_header">
                        <th data-label="checkbox"><input type="checkbox" id="check_all"></th>
                        <th data-label="title" class="left-10 align-left sort_able sort_active">Title</th>
                        <th data-label="categories"class="left-10 align-left">Categories</th>
                        <th data-label="triggers">Triggers</th>
                        <th data-label="plugins_tooltip" class="sort_able">Blocking</th>
                        <th class="toggle_filter">Turned On</th>
                    </tr>
                    
                </thead>
                <tbody id="the-list" class="filter_on__status_publish">
                    <?php 
GOON_Admin_Helper::list_content__filters( $filters );
?>
                </tbody>
                <script>
                    jQuery('table.goon_table [data-label]:not([data-label="checkbox"]):not([data-label="title"])').hide();
                </script>
            </table>
        </div>
    </div>
</div>
