<?php
$groups = get_posts( array(
	'post_type'   => 'goon_group',
	'post_status' => [ 'publish', 'trash' ],
	'numberposts' => - 1,
) );

if( $groups ){
    
    usort( $groups, "GOON_Admin_Helper::sort__by_post_title" );
}

?>

<div class="goon-wrap">

    <?php GOON_Admin_Helper::content_part__header("Groups", "groups"); ?>
    
    <div class="goon-content">
        <div class="justify-content-between global-information">
        
            <div class="col-9 left_information">
                <a href="<?php echo esc_url( admin_url('admin.php?page=goon_add_groups') ) ?>">
                    <button class="goon_green_button" id="add_elements">Create Group</button>
                </a>
                
                <?php GOON_Admin_Helper::content_part__bulk_actions(); ?>
                
                <?php GOON_Admin_Helper::content_part__manipulate_filter_options(); ?>
                
            </div>
            
            <div class="col-3 quantity">
                <span id="all_elements" class="filtered">Published</span> (<span id="count_all_elements"><?php echo wp_count_posts( 'goon_group' )->publish; ?></span>)
                |
                <span id="trash_elements">Trashed</span> (<span id="count_trash_elements"><?php echo wp_count_posts( 'goon_group' )->trash; ?></span>)
            </div>
            
        </div>
        
        <?php GOON_Admin_Helper::content_part__filter_options( $groups ); ?>
        
        <div class="row col-12">
            <div class="col-12">
                <table class="goon_table">
                    <thead>
                    
                        <tr id="search_boxes" class="toggle_filter_options hidden">
                            <th data-label="checkbox"></th>
                            <th data-label="title" class="left-10 align-left"><input type="text" placeholder="Search Title..." class="search_filter"/></th>
                            <th data-label="plugins"><input type="text" placeholder="Search Plugins..." class="search_filter"/></th>
                            <th></th>
                        </tr>
                    
                        <tr id="goon_table_header">
                            <th data-label="checkbox"><input type="checkbox" id="check_all"></th>
                            <th data-label="title" class="left-10 align-left sort_able sort_active">Title</th>
                            <th data-label="plugins">Plugins</th>
                            <th data-label="count" class="sort_able">Count</th>
                        </tr>
                        
                    </thead>
                    <tbody id="the-list" class="filter_on__status_publish">
                        <?php GOON_Admin_Helper::list_content__groups( $groups ); ?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
