<?php

$filters = get_posts( [
    'post_type'   => 'goon_filter',
    'numberposts' => -1,
] );
$filters_count = 0;
$filters_active_count = 0;
foreach ( $filters as $filter ) {
    $filters_count++;
    if ( !$filter->turned_off ) {
        $filters_active_count++;
    }
}
$categories = get_posts( [
    'post_type'   => 'goon_category',
    'numberposts' => -1,
] );
$categories_count = count( $categories );
$groups = get_posts( [
    'post_type'   => 'goon_group',
    'numberposts' => -1,
] );
$groups_count = count( $groups );
?>
<div class="wrap container">
    <div class="wrap goon-wrap">
        <div class="container">
        
            <div id="main_title">
                <h1></h1>
                <h2 id="name_page" class="$class">Overview</h2>
            </div>

            <div class="goon-content">
            
                <div class="overview_section">
                
                    <div class="summary_row">
                    
                        <div class="half first_half">
                        
                            <div>Thank you for using Goon!</div>
                            <p>We hope our plugin will help you optimize this website.</p>
                            <p>
                                If you happen to run into an issue, please tell us about it:<br/>
                                <a href="https://wordpress.org/support/plugin/goon-plugin-control/">the WordPress.org Support section</a>
                            </p>
                            <p>
                                If you like this plugin, help us promote it so other's can benefit from it too:
                                <a href="https://wordpress.org/support/plugin/goon-plugin-control/reviews/">Rate the plugin on WordPress.org</a>
                            </p>
                            
                        </div>
                    
                        <div class="half second_half">
                        
                            <div>Useful links</div>
                            <p><a href="https://wordpress.org/support/plugin/goon-plugin-control/">WordPress.org Support section</a></p>
                            <p><a href="https://wordpress.org/plugins/goon-plugin-control/#faq">WordPress.org FAQ</a></p>
                            <p><a href="https://wordpress.org/support/plugin/goon-plugin-control/reviews/">WordPress.org Reviews</a></p>
                            <p><a href="https://getgoon.pro/docs/">Documentation</a></p>
                            
                        </div>
                    
                    </div>
                    
                </div>
                
                <div class="overview_section">
                
                    <div class="summary_row">
                    
                        <div class="half first_half">
                        
                            <p>You currently have have <?php 
echo  $filters_count . _n( " filter", " filters", $filters_count ) ;
?></p>
                            
                            <?php 

if ( $filters_count ) {
    ?>
                                <p><?php 
    echo  $filters_active_count . _n( " filter is", " filters are", $filters_count ) ;
    ?> active</p>
                                <p><a href="<?php 
    echo  admin_url( 'admin.php?page=goon_filters' ) ;
    ?>">See all filters</a></p>
                            <?php 
} else {
    ?>
                                <p>You should probably <a href="<?php 
    echo  admin_url( 'admin.php?page=goon_add_filters' ) ;
    ?>">create your first filter</a></p>
                            <?php 
}

?>
                            
                        </div>
                    
                        <div class="half second_half">
                        
                            <p>
                                You currently have <?php 
echo  $categories_count . _n( " filter category", " filter categories", $categories_count ) ;
?><br/>
                                <?php 

if ( $categories_count ) {
    ?>
                                    <a href="<?php 
    echo  admin_url( 'admin.php?page=goon_filters_categories' ) ;
    ?>">See all categories</a>
                                <?php 
} else {
    ?>
                                    <a href="<?php 
    echo  admin_url( 'admin.php?page=goon_add_categories' ) ;
    ?>">create your first filter group</a>
                                <?php 
}

?>
                            </p>
                            <p>
                                You currently have <?php 
echo  $groups_count . _n( " filter group", " filter groups", $groups_count ) ;
?><br/>
                                <?php 

if ( $groups_count ) {
    ?>
                                    <a href="<?php 
    echo  admin_url( 'admin.php?page=goon_groups' ) ;
    ?>">See all groups</a>
                                <?php 
} else {
    ?>
                                    <a href="<?php 
    echo  admin_url( 'admin.php?page=goon_add_groups' ) ;
    ?>">create your first filter group</a>
                                <?php 
}

?>
                            </p>
                            
                        </div>
                    
                    </div>
                    
                </div>
                
            </div>
            
<?php 
?>
            
        </div>
    </div>
</div>
