<?php

/**
 * @wordpress-plugin
 * Plugin Name:       Goon - Control your plugins
 * Plugin URI:        https://getgoon.pro
 * Description:       The Most Powerful Performance Plugin for WordPress
 * Version:           1.2.9.2
 * Requires at least: 5.0
 * Requires PHP:      7.0
 * Author:            Goon Team
 * Author URI:        https://profiles.wordpress.org/getgoon/
 * License:           GPL-2.0+
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       goon
 * Domain Path:       /languages
 *
 */
// If this file is called directly, abort.
if ( !defined( 'WPINC' ) ) {
    die;
}

if ( function_exists( 'goon_fs' ) ) {
    goon_fs()->set_basename( false, __FILE__ );
} else {
    
    if ( !function_exists( 'goon_fs' ) ) {
        function goon_fs()
        {
            global  $goon_fs ;
            
            if ( !isset( $goon_fs ) ) {
                require_once dirname( __FILE__ ) . '/freemius/start.php';
                $goon_fs = fs_dynamic_init( array(
                    'id'             => '9191',
                    'slug'           => 'goon-plugin-control',
                    'premium_slug'   => 'goon-pro',
                    'type'           => 'plugin',
                    'public_key'     => 'pk_b6a5670af0296111d14210515afba',
                    'is_premium'     => false,
                    'premium_suffix' => '- Pro',
                    'has_addons'     => false,
                    'has_paid_plans' => true,
                    'menu'           => array(
                    'slug'    => 'goon',
                    'contact' => false,
                    'support' => false,
                    'account' => false,
                    'pricing' => false,
                ),
                    'is_live'        => true,
                ) );
            }
            
            return $goon_fs;
        }
        
        goon_fs();
        do_action( 'goon_fs_loaded' );
    }
    
    if ( goon_fs()->is_activation_mode() ) {
        update_option( "goon_should_recreate_menu", true, false );
    }
    /**
     * Current plugin version.
     */
    define( 'GOON_VERSION', '1.2.9.2' );
    // let's install the MU plugin if it's missing or outdated and refresh
    
    if ( !file_exists( WPMU_PLUGIN_DIR . '/class-goon-mu.php' ) || !function_exists( "goon_mu_plugin" ) || goon_mu_plugin()->version !== GOON_VERSION ) {
        
        if ( !file_exists( WPMU_PLUGIN_DIR ) ) {
            mkdir( WPMU_PLUGIN_DIR );
            chmod( WPMU_PLUGIN_DIR, 0755 );
        }
        
        copy( __DIR__ . '/includes/class-goon-mu.php', WPMU_PLUGIN_DIR . '/class-goon-mu.php' );
        header( "Refresh:0" );
        return;
    }
    
    /**
     * The code that runs during plugin activation.
     */
    function activate_goon()
    {
        require_once plugin_dir_path( __FILE__ ) . 'includes/class-goon-activator.php';
        GOON_Activator::activate();
    }
    
    register_activation_hook( __FILE__, 'activate_goon' );
    /**
     * The code that runs during plugin deactivation.
     */
    function deactivate_goon()
    {
        require_once plugin_dir_path( __FILE__ ) . 'includes/class-goon-deactivator.php';
        GOON_Deactivator::deactivate();
    }
    
    register_deactivation_hook( __FILE__, 'deactivate_goon' );
    /**
     * The core plugin class that is used to define internationalization,
     * admin-specific hooks, and public-facing site hooks.
     */
    require plugin_dir_path( __FILE__ ) . 'includes/class-goon.php';
    new Goon();
    // ------------------------ Freemius
    function goon_fs_custom_icon()
    {
        return dirname( __FILE__ ) . '/assets/icon-128x128.png';
    }
    
    goon_fs()->add_filter( 'plugin_icon', 'goon_fs_custom_icon' );
    function goon_fs_before_connect()
    {
        echo  '
            <style>
                body #fs_connect{
                    margin: 75px auto 0;
                }
            </style>
        ' ;
    }
    
    // goon_fs()->add_action( 'connect/before' , 'goon_fs_before_connect' );
    // goon_fs()->add_action( 'connect/after_license_input' , 'goon_fs_before_connect' );
    // goon_fs()->add_action( 'connect/after' , 'goon_fs_before_connect' );
}

if ( !function_exists( 'write_log' ) ) {
    function write_log( $log, $text = "write_log: ", $file_name = "debug.log" )
    {
        $file = WP_CONTENT_DIR . '/' . $file_name;
        
        if ( is_array( $log ) || is_object( $log ) ) {
            error_log( $text . PHP_EOL . print_r( $log, true ) . PHP_EOL, 3, $file );
        } else {
            error_log( $text . PHP_EOL . $log . PHP_EOL . PHP_EOL, 3, $file );
        }
    
    }

}